Package: meshes
Title: MeSH Enrichment and Semantic analyses
Version: 1.39.0
Authors@R: c( person(given = "Guangchuang", family = "Yu",        email = "guangchuangyu@gmail.com",   role = c("aut", "cre")))
Description: MeSH (Medical Subject Headings) is the NLM controlled vocabulary
	     used to manually index articles for MEDLINE/PubMed. MeSH terms were
	     associated by Entrez Gene ID by three methods, gendoo, gene2pubmed and RBBH.
	     This association is fundamental for enrichment and semantic analyses.
	     meshes supports enrichment analysis (over-representation and gene set
	     enrichment analysis) of gene list or whole expression profile.
	     The semantic comparisons of MeSH terms provide quantitative ways to compute
	     similarities between genes and gene groups. meshes implemented five methods
	     proposed by Resnik, Schlicker, Jiang, Lin and Wang respectively and supports
	     more than 70 species.
Depends: R (>= 4.1.0)
Imports: enrichit, gson, AnnotationDbi, GOSemSim (> 2.37.0), methods,
        utils, AnnotationHub, MeSHDbi, yulab.utils (>= 0.1.5)
Suggests: knitr, rmarkdown, prettydoc
VignetteBuilder: knitr
ByteCompile: true
License: Artistic-2.0
URL: https://yulab-smu.top/biomedical-knowledge-mining-book/
BugReports: https://github.com/GuangchuangYu/meshes/issues
biocViews: Annotation, Clustering, MultipleComparison, Software
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.3.3
git_url: https://git.bioconductor.org/packages/meshes
git_branch: devel
git_last_commit: 5e7025f
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:37:51 UTC; biocbuild
Author: Guangchuang Yu [aut, cre]
Maintainer: Guangchuang Yu <guangchuangyu@gmail.com>

# meshes: MeSH Enrichment and Semantic analyses

[![](https://img.shields.io/badge/release%20version-1.18.0-green.svg)](https://www.bioconductor.org/packages/meshes)
[![](https://img.shields.io/badge/devel%20version-1.19.1-green.svg)](https://github.com/guangchuangyu/meshes)
[![Bioc](http://www.bioconductor.org/shields/years-in-bioc/meshes.svg)](https://www.bioconductor.org/packages/devel/bioc/html/meshes.html#since)
[![codecov](https://codecov.io/gh/GuangchuangYu/meshes/branch/master/graph/badge.svg)](https://codecov.io/gh/GuangchuangYu/meshes)

[![Project Status: Active - The project has reached a stable, usable
state and is being actively
developed.](http://www.repostatus.org/badges/latest/active.svg)](http://www.repostatus.org/#active)
[![platform](http://www.bioconductor.org/shields/availability/devel/meshes.svg)](https://www.bioconductor.org/packages/devel/bioc/html/meshes.html#archives)
[![Build
Status](http://www.bioconductor.org/shields/build/devel/bioc/meshes.svg)](https://bioconductor.org/checkResults/devel/bioc-LATEST/meshes/)
[![Linux/Mac Travis Build
Status](https://img.shields.io/travis/GuangchuangYu/meshes/master.svg?label=Mac%20OSX%20%26%20Linux)](https://travis-ci.org/GuangchuangYu/meshes)
[![AppVeyor Build
Status](https://img.shields.io/appveyor/ci/Guangchuangyu/meshes/master.svg?label=Windows)](https://ci.appveyor.com/project/GuangchuangYu/meshes)

MeSH (Medical Subject Headings) is the NLM controlled vocabulary used to
manually index articles for MEDLINE/PubMed. MeSH terms were associated
by Entrez Gene ID by three methods, gendoo, gene2pubmed and RBBH. This
association is fundamental for enrichment and semantic analyses. meshes
supports enrichment analysis (over-representation and gene set
enrichment analysis) of gene list or whole expression profile. The
semantic comparisons of MeSH terms provide quantitative ways to compute
similarities between genes and gene groups. meshes implemented five
methods proposed by Resnik, Schlicker, Jiang, Lin and Wang respectively
and supports more than 70 species.

For details, please visit
<https://yulab-smu.top/biomedical-knowledge-mining-book/>.

## :writing_hand: Authors

Guangchuang YU <https://yulab-smu.top>

School of Basic Medical Sciences, Southern Medical University

[![Twitter](https://img.shields.io/twitter/url/http/shields.io.svg?style=social&logo=twitter)](https://twitter.com/intent/tweet?hashtags=ReactomePA&url=https://academic.oup.com/bioinformatics/article/34/21/3766/5001391&screen_name=guangchuangyu)
[![saythanks](https://img.shields.io/badge/say-thanks-ff69b4.svg)](https://saythanks.io/to/GuangchuangYu)
[![](https://img.shields.io/badge/follow%20me%20on-WeChat-green.svg)](https://guangchuangyu.github.io/blog_images/biobabble.jpg)

<!--

----------------------------------------------------------------------------------------


### Download stats

r badge_download_bioc("meshes")
r badge_bioc_download("meshes", "total", "blue")
r badge_bioc_download("meshes", "month", "blue")


<img src="https://guangchuangyu.github.io/software/meshes/index_files/figure-html/dlstats-1.png" width="890"/>




-->

library(MeSH.PCR.db)
kts <- keytypes(MeSH.PCR.db)
kt <- kts[2]

cls = columns(MeSH.PCR.db)

ks <- keys(MeSH.PCR.db, keytype=kts[2])
res <- select(MeSH.PCR.db, keys=ks, columns=cls, keytype=kt)

meshtbl <- meshtbl[, c(2, 3, 1)]
colnames(meshtbl) <- c("meshID", "parent", "Ontology")

save("meshtbl", file="meshtbl.rda", compress='xz')

##' semantic similarity between two gene vector
##'
##'
##' @title geneSim
##' @param geneID1 gene ID vector
##' @param geneID2 gene ID vector
##' @param measure one of "Wang", "Resnik", "Rel", "Jiang" and "Lin"
##' @param combine One of "max", "avg", "rcmax", "BMA" methods, for combining semantic similarity scores of multiple DO terms associated with gene/protein.
##' @param semData gene annotation data for semantic measurement
##' @importFrom GOSemSim combineScores
##' @return score matrix
##' @export
##' @examples
##' ## library(meshes)
##' ## library(AnnotationHub)
##' ## ah <- AnnotationHub()
##' ## qr_hsa <- query(ah, c("MeSHDb", "Homo sapiens"))
##' ## filepath_hsa <- qr_hsa[[1]]
##' ## db <- MeSHDbi::MeSHDb(filepath_hsa)
##' ## hsamd <- meshdata(db, category='A', computeIC=T, database="gendoo")
##' data(hsamd)
##' geneSim("241", "251", semData=hsamd, measure="Wang", combine="BMA")
##' @author Guangchuang Yu
geneSim <- function(geneID1,
                    geneID2=NULL,
                    measure="Wang",
                    combine="BMA",
                    semData) {

    if (!exists(".meshesEnv")) .initial()

    meshid1 <- lapply(geneID1, gene2MeSH, semData=semData)
    if (is.null(geneID2)) {
        geneID2 <- geneID1
        meshid2 <- meshid1
    } else {
        meshid2 <- lapply(geneID2, gene2MeSH, semData=semData)
    }

    m <- length(geneID1)
    n <- length(geneID2)
    scores <- matrix(NA, nrow=m, ncol=n)
    rownames(scores) <- geneID1
    colnames(scores) <- geneID2

    for (i in 1:m) {
        if (length(geneID1) == length(geneID2) && all(geneID1 == geneID2)) {
           nn <- i
           flag <- TRUE
        } else {
            flag <- FALSE
            nn <- n
        }

        for (j in 1:nn) {
            if(any(!is.na(meshid1[[i]])) &&  any(!is.na(meshid2[[j]]))) {
                s <- meshSim(meshid1[[i]],
                           meshid2[[j]],
                           measure,
                           semData
                           )
                scores[i,j] = combineScores(s, combine)
                if (flag == TRUE && j != i) {
                    scores[j, i] <- scores[i,j]
                }
            }
        }
    }
    if (nrow(scores) == 1 & ncol(scores) == 1)
        scores = as.numeric(scores)
    return(scores)
}


gene2MeSH <- function(geneID, semData) {
    meshAnno <- semData@geneAnno
    meshAnno[meshAnno$GENEID == geneID, "MESHID"]
}

##' MeSH term enrichment analysis
##'
##'
##' @title enrichMeSH
##' @param gene a vector of entrez gene id
##' @param MeSHDb MeSHDb
##' @param database one of 'gendoo', 'gene2pubmed' or 'RBBH'
##' @param category one of "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L","M", "N", "V", "Z"
##' @param pvalueCutoff Cutoff value of pvalue.
##' @param pAdjustMethod one of "holm", "hochberg", "hommel", "bonferroni", "BH", "BY", "fdr", "none"
##' @param universe background genes
##' @param minGSSize minimal size of genes annotated by Ontology term for testing.
##' @param maxGSSize maximal size of genes annotated for testing
##' @param qvalueCutoff qvalue cutoff
##' @param meshdbVersion version of MeSH.db. If NULL(the default), use the latest version.
##' @return An \code{enrichResult} instance.
##' @importClassesFrom enrichit enrichResult
##' @importFrom enrichit ora_gson
##' @export
##' @seealso \code{class?enrichResult}
##' @examples
##' \dontrun{
##' library(meshes)
##' library(AnnotationHub)
##' ah <- AnnotationHub()
##' qr_hsa <- query(ah, c("MeSHDb", "Homo sapiens"))
##' filepath_hsa <- qr_hsa[[1]]
##' db <- MeSHDbi::MeSHDb(filepath_hsa)
##' data(geneList, package="DOSE")
##' de <- names(geneList)[1:100]
##' x <- enrichMeSH(de, MeSHDb = db, database='gendoo', category = 'C')
##' }
##' @author Guangchuang Yu
enrichMeSH <- function(gene,
                       MeSHDb,
                       database = 'gendoo',
                       category = 'C',
                       pvalueCutoff=0.05,
                       pAdjustMethod="BH",
                       universe = NULL,
                       minGSSize = 10,
                       maxGSSize = 500,
                       qvalueCutoff = 0.2,
                       meshdbVersion = NULL) {

    MeSH_DATA <- get_MeSH_data(MeSHDb, database, category)

    res <- ora_gson(gene = gene,
                    pvalueCutoff=pvalueCutoff,
                    pAdjustMethod=pAdjustMethod,
                    universe = universe,
                    minGSSize = minGSSize,
                    maxGSSize = maxGSSize,
                    qvalueCutoff = qvalueCutoff,
                    gson = MeSH_DATA
                    )

    return(res)
}


##' @importFrom yulab.utils get_fun_from_pkg
##' @importFrom gson gson
get_MeSH_data <- function(MeSHDb, database, category) {
    .meshesenv <- get_mesh_env()
    
    if (exists("meshtable", envir=.meshesenv)) {
        mesh <- get("meshtable", envir = .meshesenv)
    } else {
        ## db <- get_fun_from_pkg(MeSHDb, MeSHDb)
        mesh <- select(MeSHDb, keys=database, columns = c("GENEID", "MESHID","MESHCATEGORY"), keytype = "SOURCEDB")
        assign("meshtable", mesh, envir = .meshesenv)
    }

    category <- toupper(category)
    categories <- c("A", "B", "C", "D",
                    "E", "F", "G", "H",
                    "I", "J", "K", "L",
                    "M", "N", "V", "Z")

    if (!all(category %in% categories)) {
        stop("please check your 'category' parameter...")
    }

    mesh <- mesh[ mesh[,3] %in% category, ]
    mesh2gene <- mesh[, c(2,1)]

    ## meshdb <- get_fun_from_pkg("MeSH.db", "MeSH.db")
    mesh2name <- select(MeSHDb, keys=unique(mesh2gene[,1]), columns=c('MESHID', 'MESHTERM'), keytype='MESHID')

    gson(gsid2gene = mesh2gene, 
        gsid2name = mesh2name, 
        species = get_organism(MeSHDb),
        gsname = "MeSH")
}

##' semantic similarity between two MeSH term vectors
##'
##' 
##' @title meshSim
##' @param meshID1 MeSH term vector 
##' @param meshID2 MeSH term vector 
##' @param measure one of "Wang", "Resnik", "Rel", "Jiang" and "Lin"
##' @param semData annotation data for semantic measurement, output by meshdata function 
##' @return score matrix
##' @importFrom GOSemSim termSim
##' @export
##' @examples
##' ## library(meshes)
##' ## library(AnnotationHub)
##' ## ah <- AnnotationHub()
##' ## qr_hsa <- query(ah, c("MeSHDb", "Homo sapiens"))
##' ## filepath_hsa <- qr_hsa[[1]]
##' ## db <- MeSHDbi::MeSHDb(filepath_hsa)
##' ## hsamd <- meshdata(db, category='A', computeIC=T, database="gendoo")
##' data(hsamd)
##' meshSim("D000009", "D009130", semData=hsamd, measure="Resnik")
##' @author Guangchuang Yu \url{https://guangchuangyu.github.io}
meshSim <- function(meshID1,
                    meshID2,
                    measure = "Wang",
                    semData) {
    if (!exists(".meshesEnv")) .initial()
    
    scores <- termSim(meshID1, meshID2, semData, measure)
    if(nrow(scores) == 1 & ncol(scores) == 1)
        scores <- as.numeric(scores)
    return(scores)
}

.initial <- function() {
    pos <- 1
    envir <- as.environment(pos) 
    
    assign(".meshesEnv", new.env(), envir = envir)
    .meshesEnv <- get(".meshesEnv", envir = .GlobalEnv)
    tryCatch(utils::data(list="meshtbl",
                         package = "meshes"))
    meshtbl <- get("meshtbl")
    assign("meshtbl", meshtbl, envir = .meshesEnv)
    rm(meshtbl, envir=.GlobalEnv)
}

##' construct annoData for semantic measurement
##'
##' 
##' @title meshdata
##' @param MeSHDb MeSHDb package 
##' @param database one of supported database
##' @param category one of supported category
##' @param computeIC logical value
##' @return a GOSemSimDATA object
##' @importFrom AnnotationDbi metadata
##' @importFrom AnnotationDbi keys
##' @importFrom methods new
##' @importClassesFrom GOSemSim GOSemSimDATA
##' @export
##' @examples
##' \dontrun{
##' library(meshes)
##' library(AnnotationHub)
##' ah <- AnnotationHub()
##' qr_hsa <- query(ah, c("MeSHDb", "Homo sapiens"))
##' filepath_hsa <- qr_hsa[[1]]
##' db <- MeSHDbi::MeSHDb(filepath_hsa)
##' hsamd <- meshdata(db, category='A', computeIC=T, database="gendoo")
##' }
##' @author Guangchuang Yu 
meshdata <- function(MeSHDb=NULL, database, category, computeIC = FALSE) {
    if (is.null(MeSHDb)) {
        return(new("GOSemSimDATA",
                   ont = category))
    }

    # MeSHDb <- load_OrgDb(MeSHDb)
    SOURCEDB <- keys(MeSHDb, keytype="SOURCEDB")
    if (!database %in% SOURCEDB) {
        msg <- paste0("supported database is/are '", paste(SOURCEDB, sep='/'), "', input parameter not matched...")
        stop(msg)
    }
    
    kk <- as.character(keys(MeSHDb, keytype="GENEID"))

    meshAnno <- select(MeSHDb, keys=kk, keytype="GENEID", columns = c("GENEID", "MESHCATEGORY", "MESHID", "SOURCEDB"))
    meshAnno <- meshAnno[meshAnno$SOURCEDB %in% database,]
    meshAnno <- meshAnno[meshAnno$MESHCATEGORY == category, ]

    res <- new("GOSemSimDATA",
               keys = kk,
               ont = category,
               geneAnno = meshAnno,
               metadata = metadata(MeSHDb)
               )
    
    if (computeIC) {
        res@IC = computeIC(meshAnno, category)
    }
    
    return(res)
}

## @importFrom MeSH.AOR.db MeSH.AOR.db
##' @importFrom AnnotationDbi select
computeIC <- function(meshAnno, category) {
    meshdata <- get("meshtbl", envir=.meshesEnv)
    meshids <- unique(meshdata[meshdata$Ontology == category, "meshID"])

    meshterms <- meshAnno$MESHID
    meshcount <- table(meshterms)
    meshname <- names(meshcount)

    mesh.diff <- setdiff(meshids, meshname)
    m <- double(length(mesh.diff))
    names(m) <- mesh.diff
    meshcount <- as.vector(meshcount)
    names(meshcount) <- meshname

    ## offspring.df <- select(MeSH.AOR.db, keys=category, columns=c("ANCESTOR", "OFFSPRING"), keytype="CATEGORY")
    ## Offsprings <- split(offspring.df$OFFSPRING, offspring.df$ANCESTOR) 
    Offsprings <- lapply(meshids, getOffsprings)
    names(Offsprings) <- meshids
    cnt <- meshcount[meshids] + sapply(meshids, function(i) sum(meshcount[Offsprings[[i]]], na.rm=TRUE))
    names(cnt) <- meshids

    p <- cnt/sum(meshcount)
    IC <- -log(p)
    return(IC)
}

getOffsprings <- function(meshID) {
    meshtbl <- get("meshtbl", envir=.meshesEnv)
    res <- c()
    id <- meshID
    while(any(id %in% meshtbl$parent)) {
        cid <- meshtbl[meshtbl$parent %in% id, "meshID"]
        res <- c(res, cid)
        id <- cid
    }
    return(unique(res))
}

getAncestors <- function(meshID) {
    meshtbl <- get("meshtbl", envir=.meshesEnv)
    res <- c()
    id <- meshID
    while(any(id %in% meshtbl$meshID)) {
        pid <- meshtbl[meshtbl$meshID %in% id, "parent"]
        res <- c(res, pid)
        id <- pid
    }
    return(unique(res))
}



#' Get MeSH.db
#'
#' @param meshdbVersion version of MeSH.db. Using latest version if meshdbVersion was set to NULL
#' @importFrom AnnotationHub AnnotationHub
#' @importFrom AnnotationHub query
#' @noRd
get_meshdb <- function(meshdbVersion = NULL) {
    .meshesEnv <- get_mesh_env()
    if (exists("meshdb", envir = .meshesEnv) &&
        exists("meshdbVersion", envir = .meshesEnv)) {
        meshdbVersion2 <- get('meshdbVersion', envir = .meshesEnv)
        if (identical(meshdbVersion,  meshdbVersion2)) {
            meshdb <- get("meshdb", envir = .meshesEnv)
            return(meshdb)
        }
    }
   
    ah <- AnnotationHub::AnnotationHub()
    if (is.null(meshdbVersion)) {
        dbfile <- AnnotationHub::query(ah, c("MeSHDb", "MeSH.db"))[[1]]
    } else {
        dbfile <- AnnotationHub::query(ah, c("MeSHDb", "MeSH.db", meshdbVersion))[[1]]
    }
    
    meshdb <- MeSHDbi::MeSHDb(dbfile)
    assign("meshdb", meshdb, envir = .meshesEnv)
    assign("meshdbVersion", meshdbVersion, envir = .meshesEnv)
    return(meshdb)
}


get_mesh_env <- function () {
    if (!exists(".meshesEnv")) .initial()
    get(".meshesEnv", envir = .GlobalEnv)
}

##' @importMethodsFrom enrichit show
##' @importMethodsFrom enrichit summary
##'
##' @importFrom enrichit geneID
##' @export
enrichit::geneID

##' @importFrom enrichit geneInCategory
##' @export
enrichit::geneInCategory

##' @importFrom GOSemSim get_organism
##' @export
GOSemSim::get_organism

##' Gene Set Enrichment Analysis of MeSH
##'
##'
##' @title gseMeSH
##' @param geneList order ranked geneList
##' @param MeSHDb MeSHDb
##' @param database one of 'gendoo', 'gene2pubmed' or 'RBBH'
##' @param category one of "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L","M", "N", "V", "Z"
##' @param nPerm number of permutations.
##' @param exponent weight of each step
##' @param minGSSize minimal size of each geneSet for analyzing
##' @param maxGSSize maximal size of genes annotated for testing
##' @param pvalueCutoff pvalue Cutoff
##' @param pAdjustMethod pvalue adjustment method
##' @param verbose print message or not
##' @param ... other parameter
##' @importClassesFrom enrichit gseaResult
##' @importFrom enrichit gsea_gson
##' @export
##' @return gseaResult object
##' @examples
##' \dontrun{
##' library(meshes)
##' library(AnnotationHub)
##' ah <- AnnotationHub()
##' qr_hsa <- query(ah, c("MeSHDb", "Homo sapiens"))
##' filepath_hsa <- qr_hsa[[1]]
##' db <- MeSHDbi::MeSHDb(filepath_hsa)
##' data(geneList, package="DOSE")
##' y <- gseMeSH(geneList, MeSHDb = db, database = 'gene2pubmed', category = "G")
##' }
##' @author Yu Guangchuang
gseMeSH <- function(geneList,
                    MeSHDb,
                    database      = 'gendoo',
                    category      = 'C',
                    nPerm         = 1000,
                    exponent      = 1,
                    minGSSize     = 10,
                    maxGSSize     = 500,
                    pvalueCutoff  = 0.05,
                    pAdjustMethod = "BH",
                    verbose       = TRUE,
                    ...) {

    MeSH_DATA <- get_MeSH_data(MeSHDb, database, category)
    
    res <-  gsea_gson(geneList         = geneList,
                      gson             = MeSH_DATA,
                      nPerm            = nPerm,
                      exponent         = exponent,
                      minGSSize        = minGSSize,
                      maxGSSize        = maxGSSize,
                      pvalueCutoff     = pvalueCutoff,
                      pAdjustMethod    = pAdjustMethod,
                      verbose          = verbose,
                      ...)
    
    res@setType <- "MeSH"

    return(res)
}

## ##' @importFrom enrichplot cnetplot
## ##' @export
## enrichplot::cnetplot

## ##' @importFrom enrichplot dotplot
## ##' @export
## enrichplot::dotplot

## ##' @importFrom enrichplot emapplot
## ##' @export
## enrichplot::emapplot


## ##' @importFrom enrichplot gseaplot
## ##' @export
## enrichplot::gseaplot

## ##' @importFrom enrichplot heatplot
## ##' @export
## enrichplot::heatplot

## ##' @importFrom enrichplot ridgeplot
## ##' @export
## enrichplot::ridgeplot

---
title: "MeSH Enrichment and Semantic Analyses"
author: 
- name: Guangchuang Yu
  email: guangchuangyu@gmail.com
  affiliation: Department of Bioinformatics, School of Basic Medical Sciences, Southern Medical University
date: "`r Sys.Date()`"
biblio-style: apalike
output:
  prettydoc::html_pretty:
    toc: true
    theme: cayman
    highlight: github
  pdf_document:
    toc: true
vignette: >
  % \VignetteIndexEntry{meshes}
  % \VignetteEngine{knitr::rmarkdown}
  % \usepackage[utf8]{inputenc}
  %\VignetteEncoding{UTF-8}
---

```{r style, echo=FALSE, results="asis", message=FALSE}
knitr::opts_chunk$set(tidy = FALSE,
                      warning = FALSE,
                      message = FALSE)
```

```{r echo=FALSE, results="hide", message=FALSE}
Biocpkg <- function (pkg) {
    sprintf("[%s](http://bioconductor.org/packages/%s)", pkg, pkg)
}
```



# Vignette

Please go to <https://yulab-smu.top/biomedical-knowledge-mining-book/> for the full vignette.


# Citation

If you use `r Biocpkg("meshes")` in published research, please cite the most appropriate paper(s):

__*G Yu*__. Using meshes for MeSH term enrichment and semantic analyses. __*Bioinformatics*__ 2018, 34(21):3766-3767. <https://dx.doi.org/10.1093/bioinformatics/bty410>.


# Need helps?


If you have questions/issues, please post to [Bioconductor support site](https://support.bioconductor.org/) and tag your post with *meshes*.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilities.R
\name{meshdata}
\alias{meshdata}
\title{meshdata}
\usage{
meshdata(MeSHDb = NULL, database, category, computeIC = FALSE)
}
\arguments{
\item{MeSHDb}{MeSHDb package}

\item{database}{one of supported database}

\item{category}{one of supported category}

\item{computeIC}{logical value}
}
\value{
a GOSemSimDATA object
}
\description{
construct annoData for semantic measurement
}
\examples{
\dontrun{
library(meshes)
library(AnnotationHub)
ah <- AnnotationHub()
qr_hsa <- query(ah, c("MeSHDb", "Homo sapiens"))
filepath_hsa <- qr_hsa[[1]]
db <- MeSHDbi::MeSHDb(filepath_hsa)
hsamd <- meshdata(db, category='A', computeIC=T, database="gendoo")
}
}
\author{
Guangchuang Yu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geneSim.R
\name{geneSim}
\alias{geneSim}
\title{geneSim}
\usage{
geneSim(geneID1, geneID2 = NULL, measure = "Wang", combine = "BMA", semData)
}
\arguments{
\item{geneID1}{gene ID vector}

\item{geneID2}{gene ID vector}

\item{measure}{one of "Wang", "Resnik", "Rel", "Jiang" and "Lin"}

\item{combine}{One of "max", "avg", "rcmax", "BMA" methods, for combining semantic similarity scores of multiple DO terms associated with gene/protein.}

\item{semData}{gene annotation data for semantic measurement}
}
\value{
score matrix
}
\description{
semantic similarity between two gene vector
}
\examples{
## library(meshes)
## library(AnnotationHub)
## ah <- AnnotationHub()
## qr_hsa <- query(ah, c("MeSHDb", "Homo sapiens"))
## filepath_hsa <- qr_hsa[[1]]
## db <- MeSHDbi::MeSHDb(filepath_hsa)
## hsamd <- meshdata(db, category='A', computeIC=T, database="gendoo")
data(hsamd)
geneSim("241", "251", semData=hsamd, measure="Wang", combine="BMA")
}
\author{
Guangchuang Yu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/meshes-package.R
\docType{package}
\name{meshes-package}
\alias{meshes}
\alias{meshes-package}
\title{meshes: MeSH Enrichment and Semantic analyses}
\description{
MeSH (Medical Subject Headings) is the NLM controlled vocabulary used to manually index articles for MEDLINE/PubMed. MeSH terms were associated by Entrez Gene ID by three methods, gendoo, gene2pubmed and RBBH. This association is fundamental for enrichment and semantic analyses. meshes supports enrichment analysis (over-representation and gene set enrichment analysis) of gene list or whole expression profile. The semantic comparisons of MeSH terms provide quantitative ways to compute similarities between genes and gene groups. meshes implemented five methods proposed by Resnik, Schlicker, Jiang, Lin and Wang respectively and supports more than 70 species.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://yulab-smu.top/biomedical-knowledge-mining-book/}
  \item Report bugs at \url{https://github.com/GuangchuangYu/meshes/issues}
}

}
\author{
\strong{Maintainer}: Guangchuang Yu \email{guangchuangyu@gmail.com}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/meshSim.R
\name{meshSim}
\alias{meshSim}
\title{meshSim}
\usage{
meshSim(meshID1, meshID2, measure = "Wang", semData)
}
\arguments{
\item{meshID1}{MeSH term vector}

\item{meshID2}{MeSH term vector}

\item{measure}{one of "Wang", "Resnik", "Rel", "Jiang" and "Lin"}

\item{semData}{annotation data for semantic measurement, output by meshdata function}
}
\value{
score matrix
}
\description{
semantic similarity between two MeSH term vectors
}
\examples{
## library(meshes)
## library(AnnotationHub)
## ah <- AnnotationHub()
## qr_hsa <- query(ah, c("MeSHDb", "Homo sapiens"))
## filepath_hsa <- qr_hsa[[1]]
## db <- MeSHDbi::MeSHDb(filepath_hsa)
## hsamd <- meshdata(db, category='A', computeIC=T, database="gendoo")
data(hsamd)
meshSim("D000009", "D009130", semData=hsamd, measure="Resnik")
}
\author{
Guangchuang Yu \url{https://guangchuangyu.github.io}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrichMeSH.R
\name{enrichMeSH}
\alias{enrichMeSH}
\title{enrichMeSH}
\usage{
enrichMeSH(
  gene,
  MeSHDb,
  database = "gendoo",
  category = "C",
  pvalueCutoff = 0.05,
  pAdjustMethod = "BH",
  universe = NULL,
  minGSSize = 10,
  maxGSSize = 500,
  qvalueCutoff = 0.2,
  meshdbVersion = NULL
)
}
\arguments{
\item{gene}{a vector of entrez gene id}

\item{MeSHDb}{MeSHDb}

\item{database}{one of 'gendoo', 'gene2pubmed' or 'RBBH'}

\item{category}{one of "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L","M", "N", "V", "Z"}

\item{pvalueCutoff}{Cutoff value of pvalue.}

\item{pAdjustMethod}{one of "holm", "hochberg", "hommel", "bonferroni", "BH", "BY", "fdr", "none"}

\item{universe}{background genes}

\item{minGSSize}{minimal size of genes annotated by Ontology term for testing.}

\item{maxGSSize}{maximal size of genes annotated for testing}

\item{qvalueCutoff}{qvalue cutoff}

\item{meshdbVersion}{version of MeSH.db. If NULL(the default), use the latest version.}
}
\value{
An \code{enrichResult} instance.
}
\description{
MeSH term enrichment analysis
}
\examples{
\dontrun{
library(meshes)
library(AnnotationHub)
ah <- AnnotationHub()
qr_hsa <- query(ah, c("MeSHDb", "Homo sapiens"))
filepath_hsa <- qr_hsa[[1]]
db <- MeSHDbi::MeSHDb(filepath_hsa)
data(geneList, package="DOSE")
de <- names(geneList)[1:100]
x <- enrichMeSH(de, MeSHDb = db, database='gendoo', category = 'C')
}
}
\seealso{
\code{class?enrichResult}
}
\author{
Guangchuang Yu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gseMeSH.R
\name{gseMeSH}
\alias{gseMeSH}
\title{gseMeSH}
\usage{
gseMeSH(
  geneList,
  MeSHDb,
  database = "gendoo",
  category = "C",
  nPerm = 1000,
  exponent = 1,
  minGSSize = 10,
  maxGSSize = 500,
  pvalueCutoff = 0.05,
  pAdjustMethod = "BH",
  verbose = TRUE,
  ...
)
}
\arguments{
\item{geneList}{order ranked geneList}

\item{MeSHDb}{MeSHDb}

\item{database}{one of 'gendoo', 'gene2pubmed' or 'RBBH'}

\item{category}{one of "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L","M", "N", "V", "Z"}

\item{nPerm}{number of permutations.}

\item{exponent}{weight of each step}

\item{minGSSize}{minimal size of each geneSet for analyzing}

\item{maxGSSize}{maximal size of genes annotated for testing}

\item{pvalueCutoff}{pvalue Cutoff}

\item{pAdjustMethod}{pvalue adjustment method}

\item{verbose}{print message or not}

\item{...}{other parameter}
}
\value{
gseaResult object
}
\description{
Gene Set Enrichment Analysis of MeSH
}
\examples{
\dontrun{
library(meshes)
library(AnnotationHub)
ah <- AnnotationHub()
qr_hsa <- query(ah, c("MeSHDb", "Homo sapiens"))
filepath_hsa <- qr_hsa[[1]]
db <- MeSHDbi::MeSHDb(filepath_hsa)
data(geneList, package="DOSE")
y <- gseMeSH(geneList, MeSHDb = db, database = 'gene2pubmed', category = "G")
}
}
\author{
Yu Guangchuang
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/meshes.R
\docType{data}
\name{mesh_term_table}
\alias{mesh_term_table}
\alias{meshtbl}
\alias{hsamd}
\title{DATA Sets}
\description{
These datasets are used in meshes
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DOSE.R
\docType{import}
\name{reexports}
\alias{reexports}
\alias{geneID}
\alias{geneInCategory}
\alias{get_organism}
\title{Objects exported from other packages}
\keyword{internal}
\description{
These objects are imported from other packages. Follow the links
below to see their documentation.

\describe{
  \item{enrichit}{\code{\link[enrichit]{geneID}}, \code{\link[enrichit]{geneInCategory}}}

  \item{GOSemSim}{\code{\link[GOSemSim]{get_organism}}}
}}
